// pair.i - SWIG interface
%module Buffy

%include std_string.i
%include std_vector.i

//%feature("director");

%exception {
	try { $action }
	catch (...) { SWIG_fail; }
}

%{
#include "MailFolder.h"
#include "Config.h"

using namespace buffy;
%}

%ignore buffy::SmartPointer;
%ignore buffy::SmartPointerItem;

// Parse the original header file
%include "SmartPointer.h"
%include "Consumer.h"
%include "Config.h"

// Instantiate the base class needed for MailFolder, but dont wrap it
%template() buffy::SmartPointer<buffy::MailFolderImpl>;
%template() buffy::SmartPointer<buffy::MailProgramImpl>;
%template(MailFolderVector) std::vector<buffy::MailFolder>;
%template(MailProgramVector) std::vector<buffy::MailProgram>;
%template(StringVector) std::vector<std::string>;

%ignore MailProgramImpl;
%include "MailProgram.h"

%ignore MailFolderImpl;
%include "MailFolder.h"

// TODO:
// Rename the static method to be called as MailFolder.enumerateFolders
// (or even as Buffy.enumerateFolders?)
